package org.rosuda.jrs;

import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptException;

/**
 * Combines the ScriptEngine and Invocable interfaces along with call and close methods.
 * @author Martyn Tebby
 */
public interface ScriptEngineEx extends ScriptEngine, Invocable {

	/**
	 * Call a function or object method.
	 * @param returnType The Class of the returned data, maybe null.
	 * @param obj The Object on which the method is called, maybe null.
	 * @param function The name of the function or object method to call.
	 * @param args The arguments to pass to the call.
	 * @return The result of the call.
	 */
	<T> T call(Class<T> returnType, Object obj, String function, Object... args)
    throws ScriptException; //, NoSuchMethodException;

	/**
	 * Close the script engine.
	 */
	void close();

}
